import Test.HUnit
import Data.Maybe

import qualified Runner
import qualified Configuration

samplesPath = "tests/samples/"

imageFiles = ["hello.jpg", "pixel.jpg", "cat.jpg", "cubes.png", "diablo.png"]
zipFiles = ["gtk3.zip"]

allEngines = Runner.defaultPriority
fileEngines = ["rghost", "ompldr"]

testEngineOnFile :: String -> String -> Configuration.Configuration -> IO ()
testEngineOnFile engine file config = do
  result <- Runner.runArgs [engine, samplesPath ++ file] config
  assertBool ("test_" ++ show engine ++ "_" ++ show file) (isJust result)

makeTestLabel file engine = TestLabel
                            ("test_" ++ engine ++ "_" ++ file)
                            (TestCase (testEngineOnFile engine file Configuration.dummyConf))

genLabels files engines = [makeTestLabel f e | f <- files, e <- engines]

tests = TestList $ genLabels imageFiles allEngines ++ genLabels zipFiles fileEngines

main :: IO ()
main = do
  foo <- runTestTT tests
  return ()
